package com.ruoyi.web.v1.mapper;

import java.util.List;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.web.v1.model.Staff;
import com.ruoyi.web.v1.model.StaffPost;
import org.apache.ibatis.annotations.Param;

/**
 * 人员Mapper接口
 * 
 * @author coede
 * @date 2025-03-20
 */
public interface StaffMapper extends BaseMapper<Staff>
{
    /**
     * 查询人员
     * 
     * @param id 人员主键
     * @return 人员
     */
    public Staff selectStaffById(Long id);

    /**
     * 查询人员列表
     * @return 人员集合
     */
    public Page<Staff> selectStaffList(Page<Staff> page, @Param("realname") String realname,
                                       @Param("postId") Long postId, @Param("phone") String phone);

    public List<Staff> selectStaffList(@Param("realname") String realname, @Param("postId") Long postId,
                                       @Param("phone") String phone);

    /**
     * 新增人员
     * 
     * @param staff 人员
     * @return 结果
     */
    public int insertStaff(Staff staff);

    /**
     * 修改人员
     * 
     * @param staff 人员
     * @return 结果
     */
    public int updateStaff(Staff staff);

    /**
     * 删除人员
     * 
     * @param id 人员主键
     * @return 结果
     */
    public int deleteStaffById(Long id);

    /**
     * 批量删除人员
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteStaffByIds(Long[] ids);

    /**
     * 根据岗位ID获取人员数量
     *
     * @param postId 岗位ID
     * @return 结果
     */
    public int countStaffByPostId(Long postId);

    /**
     * 批量新增人员岗位信息
     *
     * @param staffPostList 人员岗位列表
     * @return 结果
     */
    public int batchStaffPost(List<StaffPost> staffPostList);

    /**
     * 通过人员ID删除人员和岗位关联
     *
     * @param staffId 人员ID
     * @return 结果
     */
    public int deleteStaffPostByStaffId(Long staffId);

}
